local _
local whispers = {}

local function Aliaseses_ParseText(chatEntry, send)
	if send ~= 1 then
		local a, m, t, s

		m = chatEntry:GetText()
		a = strfind(m, " ")
		if a == nil then
			a = 2
		else
			a = a + 1
		end
		t = m:sub(1, a-2)

		if tContains(whispers, t) then
			s = Aliaseses_DB["aliases"][m:sub(a, m:len())]
			if s ~= nil then
				chatEntry:SetText(t .. ' ' .. s)
			end
		end
	end
end

local function Aliaseses_GetCmd(msg)
	if msg then
		local a, b, c = strfind(msg, "(%S+)")
		if a then
			return c, strsub(msg, b+2)
		else	
			return ""
		end
	end
end

local function Aliaseses_Command(msg)
	local cmd, subCmd = Aliaseses_GetCmd(msg)
	if cmd == "add" then
		local cmd, subCmd = Aliaseses_GetCmd(subCmd)
		if not Aliaseses_DB["aliases"][cmd:lower()] then
			if subCmd and subCmd ~= "" then
				Aliaseses_DB["aliases"][cmd:lower()] = subCmd:lower()
				print("Aliaseses - Alias for '" .. subCmd .. "' created as '" .. cmd .. "'.")
			else
				print("Aliaseses - Usage: '/alias add <alias> <name>'.")
			end
		else
			print("Aliaseses - That alias already exists.")
		end
	elseif cmd == "remove" then
		local cmd, subCmd = Aliaseses_GetCmd(subCmd)
		if cmd and Aliaseses_DB["aliases"][cmd:lower()] then
			Aliaseses_DB["aliases"][cmd:lower()] = nil
			print("Aliaseses - The alias '" .. cmd .. "' was successfully removed.")
		else
			print("Aliaseses - That alias does not exist.")
		end
	elseif cmd == "list" then
		msg = 0
		for k, v in pairs(Aliaseses_DB["aliases"]) do
			if msg == 0 then
				print("Aliaseses - Current list of aliases:")
				msg = 1
			end
			print(" " .. k .. " => " .. v)
		end
		if  msg == 0 then
			print("Aliaseses - Currently no aliases set up.")
		end
	elseif cmd == "reset" then
		if subCmd == "yes" then
			Aliaseses_DB["aliases"] = {}
			print("Aliaseses - Database successfully reset!")
		else
			print("Aliaseses - This will reset your alias database completely. If you are sure type '/alias reset yes'.")
		end
	else
		msg = {
			"Aliaseses - Commands:",
			" 'add' to add additional aliases.",
			" 'remove' to remove aliases.",
			" 'list' to list current aliases.",
			" 'help' to display this message."
			}
		for k, v in pairs(msg) do
			print(v)
		end
	end
	
end

function Aliaseses_OnLoad()
	hooksecurefunc('ChatEdit_ParseText', Aliaseses_ParseText)

	SLASH_ALIASESES1 = "/alias"
	SLASH_ALIASESES2 = "/aliaseses"
	SlashCmdList["ALIASESES"] = Aliaseses_Command
	
	if not Aliaseses_DB then
		Aliaseses_DB = {
			aliases = {}
			}
	end

	whispers = {"/w", "/whisper", "/tell", "/t", "/send"}
end